1. Packages
  2. Packages
  3. Pulumi Cloud (Pulumi Service provider)
  4. API Docs
  5. api
  6. api/esc
  7. Environment

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi
pulumiservice logo

This provider is currently in preview.

Viewing docs for Pulumi Cloud v1.1.0
published on Thursday, May 21, 2026 by Pulumi

    Creates a new Pulumi ESC (Environments, Secrets, and Configuration) environment within the specified organization. The request body must include the project name and the environment name. Environment names must be unique within a project and may only contain alphanumeric characters, hyphens, underscores, and periods. The newly created environment starts with an empty YAML definition that can be updated via the UpdateEnvironment endpoint.

    Create Environment Resource

    Resources are created with functions called constructors. To learn more about declaring and configuring resources, see Resources.

    Constructor syntax

    new Environment(name: string, args: EnvironmentArgs, opts?: CustomResourceOptions);
    @overload
    def Environment(resource_name: str,
                    args: EnvironmentArgs,
                    opts: Optional[ResourceOptions] = None)
    
    @overload
    def Environment(resource_name: str,
                    opts: Optional[ResourceOptions] = None,
                    name: Optional[str] = None,
                    org_name: Optional[str] = None,
                    project: Optional[str] = None,
                    yaml: Optional[str] = None)
    func NewEnvironment(ctx *Context, name string, args EnvironmentArgs, opts ...ResourceOption) (*Environment, error)
    public Environment(string name, EnvironmentArgs args, CustomResourceOptions? opts = null)
    public Environment(String name, EnvironmentArgs args)
    public Environment(String name, EnvironmentArgs args, CustomResourceOptions options)
    
    type: pulumiservice:api/esc:Environment
    properties: # The arguments to resource properties.
    options: # Bag of options to control resource's behavior.
    
    
    resource "pulumiservice_api_esc_environment" "name" {
        # resource properties
    }

    Parameters

    name string
    The unique name of the resource.
    args EnvironmentArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    resource_name str
    The unique name of the resource.
    args EnvironmentArgs
    The arguments to resource properties.
    opts ResourceOptions
    Bag of options to control resource's behavior.
    ctx Context
    Context object for the current deployment.
    name string
    The unique name of the resource.
    args EnvironmentArgs
    The arguments to resource properties.
    opts ResourceOption
    Bag of options to control resource's behavior.
    name string
    The unique name of the resource.
    args EnvironmentArgs
    The arguments to resource properties.
    opts CustomResourceOptions
    Bag of options to control resource's behavior.
    name String
    The unique name of the resource.
    args EnvironmentArgs
    The arguments to resource properties.
    options CustomResourceOptions
    Bag of options to control resource's behavior.

    Constructor example

    The following reference example uses placeholder values for all input properties.

    var environmentResource = new PulumiService.Api.Esc.Environment("environmentResource", new()
    {
        Name = "string",
        OrgName = "string",
        Project = "string",
        Yaml = "string",
    });
    
    example, err := esc.NewEnvironment(ctx, "environmentResource", &esc.EnvironmentArgs{
    	Name:    pulumi.String("string"),
    	OrgName: pulumi.String("string"),
    	Project: pulumi.String("string"),
    	Yaml:    pulumi.String("string"),
    })
    
    resource "pulumiservice_api_esc_environment" "environmentResource" {
      name     = "string"
      org_name = "string"
      project  = "string"
      yaml     = "string"
    }
    
    var environmentResource = new com.pulumi.pulumiservice.api.Environment("environmentResource", com.pulumi.pulumiservice.api.EnvironmentArgs.builder()
        .name("string")
        .orgName("string")
        .project("string")
        .yaml("string")
        .build());
    
    environment_resource = pulumiservice.api.esc.Environment("environmentResource",
        name="string",
        org_name="string",
        project="string",
        yaml="string")
    
    const environmentResource = new pulumiservice.api.esc.Environment("environmentResource", {
        name: "string",
        orgName: "string",
        project: "string",
        yaml: "string",
    });
    
    type: pulumiservice:api/esc:Environment
    properties:
        name: string
        orgName: string
        project: string
        yaml: string
    

    Environment Resource Properties

    To learn more about resource properties and how to use them, see Inputs and Outputs in the Architecture and Concepts docs.

    Inputs

    In Python, inputs that are objects can be passed either as argument classes or as dictionary literals.

    The Environment resource accepts the following input properties:

    Name string
    The name of the environment.
    OrgName string
    The organization name
    Project string
    The project name for the environment.
    Yaml string
    Raw YAML body content.
    Name string
    The name of the environment.
    OrgName string
    The organization name
    Project string
    The project name for the environment.
    Yaml string
    Raw YAML body content.
    name string
    The name of the environment.
    org_name string
    The organization name
    project string
    The project name for the environment.
    yaml string
    Raw YAML body content.
    name String
    The name of the environment.
    orgName String
    The organization name
    project String
    The project name for the environment.
    yaml String
    Raw YAML body content.
    name string
    The name of the environment.
    orgName string
    The organization name
    project string
    The project name for the environment.
    yaml string
    Raw YAML body content.
    name str
    The name of the environment.
    org_name str
    The organization name
    project str
    The project name for the environment.
    yaml str
    Raw YAML body content.
    name String
    The name of the environment.
    orgName String
    The organization name
    project String
    The project name for the environment.
    yaml String
    Raw YAML body content.

    Outputs

    All input properties are implicitly available as output properties. Additionally, the Environment resource produces the following output properties:

    Id string
    The provider-assigned unique ID for this managed resource.
    Id string
    The provider-assigned unique ID for this managed resource.
    id string
    The provider-assigned unique ID for this managed resource.
    id String
    The provider-assigned unique ID for this managed resource.
    id string
    The provider-assigned unique ID for this managed resource.
    id str
    The provider-assigned unique ID for this managed resource.
    id String
    The provider-assigned unique ID for this managed resource.

    Package Details

    Repository
    pulumiservice pulumi/pulumi-pulumiservice
    License
    Apache-2.0
    pulumiservice logo

    This provider is currently in preview.

    Viewing docs for Pulumi Cloud v1.1.0
    published on Thursday, May 21, 2026 by Pulumi

      Try Pulumi Cloud free.
      Your team will thank you.

      Start free trial